Subject: bug#1976 closed by Chong Yidong <[email-masked]> (Re: 23.0.50; PC-do-completion should fix case if possible)

From: [email-masked] (Emacs bug Tracking System)
Date: Wed, 28 Jan 2009 15:45:05 +0000

This is an automatic notification regarding your bug report
which was filed against the emacs package:

#1976: 23.0.50; PC-do-completion should fix case if possible

It has been closed by Chong Yidong <[email-masked]>.

Their explanation is attached below along with your original report.
If this explanation is unsatisfactory and you have not received a
better one in a separate message then please contact Chong Yidong <[email-masked]> by
replying to this email.

-- 
1976: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=1976
Emacs Bug Tracking System
Contact [email-masked] with problems

Subject: Re: 23.0.50; PC-do-completion should fix case if possible
From: Chong Yidong <[email-masked]>
To: Denis Howe <[email-masked]>
Cc: [email-masked]
Date: Wed, 28 Jan 2009 10:36:04 -0500

> > the default completion in Emacs-23 is very close to
> > partial-completion-mode
>
> OMG, so it is!  I've been using partial-completion-mode so long I
> can't remember why I turned it on.  What's even stupider is that I've
> never actually used the "partial" feature.  Thanks very much for the
> enlightenment.

In any case, I've checked in your patch to complete.el.  Thanks.

Subject: Re: 23.0.50; PC-do-completion should fix case if possible
From: Denis Howe <[email-masked]>
To: [email-masked]
Date: Wed, 21 Jan 2009 14:42:43 +0000

My 2007-10-03 attempt to get this patch applied got no further than RMS's
request for someone to DTRT.  It took several hours of my time to debug and
test, and the bug still bites me every time I re-install, so PLEASE could
someone apply it?  Thanks.
------------------------------------------------------------
In the latest complete.el from CVS (v1.94), function "PC-do-completion"
fails to correct the case of the input being completed when:

- "completion-ignore-case" is true and
- "read-file-name-completion-ignore-case" is true and
- all possible completions have the same case

Ordinary completion preserves input case only where the potential
completions differ in case.  If they agree then ordinary completion changes
the input case to that of the prefix.

For example, evaluate:

(partial-completion-mode 0)
(setq completion-ignore-case t)
(completing-read "Input: " '(("Den".1)("Denis".2)) nil t "d")

Hitting TAB runs ordinary "minibuffer-complete" which completes "d" to "Den"
(case corrected).

Enable partial completion:

(partial-completion-mode 1)

Re-evaluate the above completing-read.

Hitting TAB now runs "PC-complete" which completes "d" to "den" (fails to
correct input case).

I've tested the attached patch thoroughly.  Please contact me if you want
any more background on this.

------------------------------------------------------------

ChangeLog entry:

2009-01-21  Denis Howe <[email-masked]>

       * complete.el (PC-do-completion): Correct case when unambiguous.

------------------------------------------------------------

cvs diff -cw complete.el
Index: complete.el
===================================================================
RCS file: /sources/emacs/emacs/lisp/complete.el,v
retrieving revision 1.94
diff -c -w -r1.94 complete.el
*** complete.el    9 Jan 2009 04:44:19 -0000    1.94
--- complete.el    21 Jan 2009 14:21:17 -0000
***************
*** 737,744 ****
               (setq prefix (PC-try-completion
                     (PC-chunk-after basestr skip) poss)))
          (let ((first t) i)
-           ;; Retain capitalization of user input even if
-           ;; completion-ignore-case is set.
            (if (eq mode 'word)
                (setq prefix (PC-chop-word prefix basestr)))
            (goto-char (+ beg (length dirname)))
--- 737,742 ----
***************
*** 746,760 ****
                  (setq i 0) ; index into prefix string
                  (while (< i (length prefix))
                    (if (and (< (point) end)
                         (eq (downcase (aref prefix i))
!                            (downcase (following-char))))
!                       ;; same char (modulo case); no action
!                       (forward-char 1)
!                     (if (and (< (point) end)
                           (and (looking-at " ")
                                                    (memq (aref prefix i)
!                             PC-delims-list)))
                      ;; replace " " by the actual delimiter
                      (progn
                        (delete-char 1)
                        (insert (substring prefix i (1+ i))))
--- 744,757 ----
                  (setq i 0) ; index into prefix string
                  (while (< i (length prefix))
                    (if (and (< (point) end)
+                                            (or
                         (eq (downcase (aref prefix i))
!                                                 (downcase
(following-char)))
                           (and (looking-at " ")
                                                    (memq (aref prefix i)
!                                                        PC-delims-list))))
                      ;; replace " " by the actual delimiter
+                                       ;; or input char by prefix char
                      (progn
                        (delete-char 1)
                        (insert (substring prefix i (1+ i))))
***************
*** 766,772 ****
                                                 (setq end (1- end))))
                      (setq improved t)
                                          (insert (substring prefix i (1+
i)))
!                     (setq end (1+ end)))))
                    (setq i (1+ i)))
                  (or pt (setq pt (point)))
                  (looking-at PC-delim-regex))
--- 763,769 ----
                                                 (setq end (1- end))))
                      (setq improved t)
                                          (insert (substring prefix i (1+
i)))
!                                       (setq end (1+ end))))
                    (setq i (1+ i)))
                  (or pt (setq pt (point)))
                  (looking-at PC-delim-regex))

------------------------------------------------------------
End

-- Denis Howe <[email-masked]>